var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "typedoc/dist/lib/converter/components", "typedoc/dist/lib/models", "typedoc/dist/lib/converter/plugins", "typedoc/dist/lib/converter"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    const components_1 = require("typedoc/dist/lib/converter/components");
    const models_1 = require("typedoc/dist/lib/models");
    const plugins_1 = require("typedoc/dist/lib/converter/plugins");
    const converter_1 = require("typedoc/dist/lib/converter");
    /** This plugin renames "External Modules" to "Modules" */
    let RenameExternalModulePlugin = class RenameExternalModulePlugin extends components_1.ConverterComponent {
        initialize() {
            this.monkeyPatchGetKindPlural();
            this.monkeyPatchGetKindSingular();
            this.listenTo(this.owner, {
                [converter_1.Converter.EVENT_CREATE_DECLARATION]: this.onDeclaration,
            });
        }
        monkeyPatchGetKindPlural() {
            let realFn = plugins_1.GroupPlugin.getKindPlural;
            plugins_1.GroupPlugin.getKindPlural = function getKindPlural(kind) {
                /** Rename title of "External Modules" to simply "Modules" */
                if (kind === models_1.ReflectionKind.ExternalModule)
                    return 'Modules';
                return realFn.apply(plugins_1.GroupPlugin, arguments);
            };
        }
        monkeyPatchGetKindSingular() {
            let realFn = plugins_1.GroupPlugin.getKindSingular;
            plugins_1.GroupPlugin.getKindSingular = function getKindSingular(kind) {
                /** Rename title of "External Modules" to simply "Modules" */
                if (kind === models_1.ReflectionKind.ExternalModule)
                    return 'Module';
                return realFn.apply(plugins_1.GroupPlugin, arguments);
            };
        }
        onDeclaration(context, reflection, node) {
            // placholdeer
        }
    };
    RenameExternalModulePlugin = __decorate([
        components_1.Component({ name: 'RenameExtModule' })
    ], RenameExternalModulePlugin);
    exports.RenameExternalModulePlugin = RenameExternalModulePlugin;
});
